From f7399c9caf9d3386f722beec495106efabc3a1a9 Mon Sep 17 00:00:00 2001
From: Daan De Meyer <daan.j.demeyer@gmail.com>
Date: Jan 20 2022 16:52:29 +0000
Subject: [PATCH 10/15] journal: Store entry item offsets in trie in compact mode


In a journal file, data objects such as
"_BOOT_ID=100b7ef4c5124bc6839e28db763b4627" and "PRIORITY=6" are
referenced repeatedly; usually the only difference between two entries
is the "MESSAGE=" data object.  This results in a large amount of wasted
space, as each entry contains an array of 16-byte EntryItem pointers to
such data objects.

Instead, compress that array of items into a Trie, allowing us to only
record the difference between them:

node: pointer to _BOOT_ID=100b7ef4c5124bc6839e28db763b4627 data
  `- node: pointer to PRIORITY=6 data
      `- node: pointer to MESSAGE=foo
      `- node: pointer to MESSAGE=bar

The new Trie Node object stores an offset to the parent node, an offset
to the corresponding Data object, the next object in the hash table chain
and the hash itself. The hash we use is the XOR hash of all the Entry
items starting from the current node. In the best case scenario, this
allows us to find the correct node with just a single hash lookup.

If we assume that for most messages, all fields except MESSAGE have
already appeared in a previous message, we can compare the overhead
before and after this change per message:

(I'm not counting the EntryItem hash field as overhead here as we
can remove those regardless of whether we use a trie or not)

Before:
- A new Data object for the MESSAGE field
- A new Entry object with +- 20 64-bit offsets

After:
- A new Data object for the MESSAGE field
- A new Trie Node object for the MESSAGE field (6 * 64-bit)
- A new Entry object with a single 64-bit offset

So the Entry overhead reduces from 20 * 64-bit to 7 * 64-bit. If
we add opt-in field indexing in the future, we'll store the MESSAGE
field inline which will reduce the Entry overhead to a single 64-bit
offset for most messages.

Before:

OBJECT TYPE	 ENTRIES SIZE
Unused           0       0B
Data             3562667 591.0M
Field            3971    213.6K
Entry            3498566 1.2G
Data Hash Table  20      71.1M
Field Hash Table 20      104.3K
Entry Array      582647  505.0M
Tag              0       0B
Total            7647891 2.4G

After:

OBJECT TYPE      ENTRIES  SIZE
Unused           0        0B
Data             3521895  587.0M
Field            3140     169.4K
Entry            3499118  240.2M
Data Hash Table  14       49.7M
Field Hash Table 14       73.0K
Entry Array      577350   499.5M
Tag              0        0B
Trie Node        5767903  220.0M
Trie Hash Table  14       74.6M
Total            13369448 1.6G

---

diff --git a/src/libsystemd/sd-journal/journal-def.h b/src/libsystemd/sd-journal/journal-def.h
index 75c7a5e..7748998 100644
--- a/src/libsystemd/sd-journal/journal-def.h
+++ b/src/libsystemd/sd-journal/journal-def.h
@@ -23,6 +23,7 @@ typedef struct EntryObject EntryObject;
 typedef struct HashTableObject HashTableObject;
 typedef struct EntryArrayObject EntryArrayObject;
 typedef struct TagObject TagObject;
+typedef struct TrieNodeObject TrieNodeObject;
 
 typedef struct EntryItem EntryItem;
 typedef struct HashItem HashItem;
@@ -39,6 +40,8 @@ typedef enum ObjectType {
         OBJECT_FIELD_HASH_TABLE,
         OBJECT_ENTRY_ARRAY,
         OBJECT_TAG,
+        OBJECT_TRIE_NODE,
+        OBJECT_TRIE_HASH_TABLE,
         _OBJECT_TYPE_MAX
 } ObjectType;
 
@@ -95,17 +98,22 @@ struct EntryItem {
 typedef struct {
         uint64_t object_offset;
         uint64_t hash;
+        /* The hash used to calculate the Entry object's XOR hash field. */
+        uint64_t xor_hash;
 } EntryItemEx;
 
-#define EntryObject__contents { \
-        ObjectHeader object;    \
-        le64_t seqnum;          \
-        le64_t realtime;        \
-        le64_t monotonic;       \
-        sd_id128_t boot_id;     \
-        le64_t xor_hash;        \
-        EntryItem items[];      \
-        }
+#define EntryObject__contents {                \
+        ObjectHeader object;                   \
+        le64_t seqnum;                         \
+        le64_t realtime;                       \
+        le64_t monotonic;                      \
+        sd_id128_t boot_id;                    \
+        le64_t xor_hash;                       \
+        union {                                \
+                EntryItem items[0];            \
+                le64_t trie_offset;            \
+        };                                     \
+}
 
 struct EntryObject EntryObject__contents;
 struct EntryObject__packed EntryObject__contents _packed_;
@@ -139,6 +147,18 @@ struct TagObject {
         uint8_t tag[TAG_LENGTH]; /* SHA-256 HMAC */
 } _packed_;
 
+#define TrieNodeObject__contents { \
+        ObjectHeader object;       \
+        le64_t hash;               \
+        le32_t parent_offset;      \
+        le32_t object_offset;      \
+        le64_t next_hash_offset;   \
+}
+
+struct TrieNodeObject TrieNodeObject__contents;
+struct TrieNodeObject__packed TrieNodeObject__contents _packed_;
+assert_cc(sizeof(struct TrieNodeObject) == sizeof(struct TrieNodeObject__packed));
+
 union Object {
         ObjectHeader object;
         DataObject data;
@@ -147,6 +167,7 @@ union Object {
         HashTableObject hash_table;
         EntryArrayObject entry_array;
         TagObject tag;
+        TrieNodeObject trie_node;
 };
 
 enum {
@@ -227,12 +248,17 @@ enum {
         /* Added in 246 */                              \
         le64_t data_hash_chain_depth;                   \
         le64_t field_hash_chain_depth;                  \
+        /* Added in 251 */                              \
+        le64_t trie_hash_table_offset;                  \
+        le64_t trie_hash_table_size;                    \
+        le64_t n_trie_nodes;                            \
+        le64_t trie_hash_chain_depth;                   \
         }
 
 struct Header struct_Header__contents;
 struct Header__packed struct_Header__contents _packed_;
 assert_cc(sizeof(struct Header) == sizeof(struct Header__packed));
-assert_cc(sizeof(struct Header) == 256);
+assert_cc(sizeof(struct Header) == 288);
 
 #define FSS_HEADER_SIGNATURE                                            \
         ((const char[]) { 'K', 'S', 'H', 'H', 'R', 'H', 'L', 'P' })
